Skip to content

Google: Creates a label For more information, see Manage labels (https: developers google com workspace gmail api guides labels)

Google gmailUsersLabels.gmailUsersLabelsCreate: arguments, response, policy and SDK examples.

← Gmail users labels operations · Get started

Operation google.gmail_users_labels_create

Provider route: POST /gmail/v1/users/{userId}/labels. Alter supplies the connection’s credentials and routing.

Install @alter-ai/sdk @alter-ai/google with npm, or alter-sdk-google with pip. Supply your connected customer’s grant ID and the arguments described below.

import { App } from "@alter-ai/sdk";
import { GoogleIntegration } from "@alter-ai/google";
async function execute(input: Parameters<GoogleIntegration["gmailUsersLabels"]["gmailUsersLabelsCreate"]>[0]) {
const app = new App({ apiKey: process.env.ALTER_API_KEY! });
try {
const provider = new GoogleIntegration(app, { grantId: process.env.PROVIDER_GRANT_ID! });
const call = await provider.gmailUsersLabels.gmailUsersLabelsCreate(input);
const result = await call.wait();
return result.bodyJson();
} finally {
await app.close();
}
}
import os
from alter_sdk import App
from alter_sdk_google import GoogleIntegration
async def execute(arguments):
async with App(api_key=os.environ["ALTER_API_KEY"]) as app:
provider = GoogleIntegration(app, {"grant_id": os.environ["PROVIDER_GRANT_ID"]})
call = await provider.gmail_users_labels.gmail_users_labels_create(arguments)
result = await call.wait()
return result.body_json()
FieldTypePresenceDescription and constraints
$objectRootAdditional keys: not allowed
pathobjectRequired within parentAdditional keys: not allowed
path.userIdstringRequired within parentThe user’s email address. The special value `me` can be used to indicate the authenticated user.
Default: me
queryobjectOptionalAdditional keys: not allowed
query.fieldsstringOptionalSelector specifying which fields to include in a partial response.
query.prettyPrintbooleanOptionalReturns response with indentations and line breaks.
Default: true
query.quotaUserstringOptionalAvailable to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.
bodyModelRequired within parentExpand Creates a label For more information, see Manage labels (https: developers google com workspace gmail api guides labels) — request body — body

Referenced models: Creates a label For more information, see Manage labels (https: developers google com workspace gmail api guides labels) — request body — body

Response media type: application/json. The table describes the pinned successful response. Referenced models link to their complete fields.

FieldTypePresenceDescription and constraints
$ModelRootExpand Creates a label For more information, see Manage labels (https: developers google com workspace gmail api guides labels) — response body

Referenced models: Creates a label For more information, see Manage labels (https: developers google com workspace gmail api guides labels) — response body

Creates a label For more information, see Manage labels (https: developers google com workspace gmail api guides labels) — response body
FieldTypePresenceDescription and constraints
$objectRootLabels are used to categorize messages and threads within the user's mailbox. The maximum number of labels supported for a user's mailbox is 10,000.
colorModelOptionalExpand Creates a label For more information, see Manage labels (https: developers google com workspace gmail api guides labels) — response body — color
The color to assign to the label. Color is only available for labels that have their `type` set to `user`.
idstringOptionalThe immutable ID of the label.
labelListVisibilitystringOptionalThe visibility of the label in the label list in the Gmail web interface.
Known values: labelShow, labelShowIfUnread, labelHide
messageListVisibilitystringOptionalThe visibility of messages with this label in the message list in the Gmail web interface.
Known values: show, hide
messagesTotalJSONOptional
messagesTotal (anyOf 1)integerAlternativeThe total number of messages with the label.
Format: int32
messagesTotal (anyOf 2)stringAlternativePattern: ^-?[0-9]+(?:\.[0-9]+)?(?:[eE][+-]?[0-9]+)?$
messagesUnreadJSONOptional
messagesUnread (anyOf 1)integerAlternativeThe number of unread messages with the label.
Format: int32
messagesUnread (anyOf 2)stringAlternativePattern: ^-?[0-9]+(?:\.[0-9]+)?(?:[eE][+-]?[0-9]+)?$
namestringOptionalThe display name of the label.
threadsTotalJSONOptional
threadsTotal (anyOf 1)integerAlternativeThe total number of threads with the label.
Format: int32
threadsTotal (anyOf 2)stringAlternativePattern: ^-?[0-9]+(?:\.[0-9]+)?(?:[eE][+-]?[0-9]+)?$
threadsUnreadJSONOptional
threadsUnread (anyOf 1)integerAlternativeThe number of unread threads with the label.
Format: int32
threadsUnread (anyOf 2)stringAlternativePattern: ^-?[0-9]+(?:\.[0-9]+)?(?:[eE][+-]?[0-9]+)?$
typestringOptionalThe owner type for the label. User labels are created by the user and can be modified and deleted by the user and can be applied to any message or thread. System labels are internally created and cannot be added, modified, or deleted. System labels may be able to be applied to or removed from messages and threads under some circumstances but this is not guaranteed. For example, users can apply and remove the `INBOX` and `UNREAD` labels from messages and threads, but cannot apply or remove the `DRAFTS` or `SENT` labels from messages or threads.
Known values: system, user

Referenced models: Creates a label For more information, see Manage labels (https: developers google com workspace gmail api guides labels) — response body — color

Creates a label For more information, see Manage labels (https: developers google com workspace gmail api guides labels) — request body — body
FieldTypePresenceDescription and constraints
$objectRootLabels are used to categorize messages and threads within the user's mailbox. The maximum number of labels supported for a user's mailbox is 10,000.
colorModelOptionalExpand Creates a label For more information, see Manage labels (https: developers google com workspace gmail api guides labels) — response body — color
The color to assign to the label. Color is only available for labels that have their `type` set to `user`.
idstringOptionalThe immutable ID of the label.
labelListVisibilitystringRequired within parentThe visibility of the label in the label list in the Gmail web interface.
One of: labelShow, labelShowIfUnread, labelHide
messageListVisibilitystringRequired within parentThe visibility of messages with this label in the message list in the Gmail web interface.
One of: show, hide
messagesTotalintegerOptionalThe total number of messages with the label.
Format: int32
messagesUnreadintegerOptionalThe number of unread messages with the label.
Format: int32
namestringRequired within parentThe display name of the label.
threadsTotalintegerOptionalThe total number of threads with the label.
Format: int32
threadsUnreadintegerOptionalThe number of unread threads with the label.
Format: int32
typestringOptionalThe owner type for the label. User labels are created by the user and can be modified and deleted by the user and can be applied to any message or thread. System labels are internally created and cannot be added, modified, or deleted. System labels may be able to be applied to or removed from messages and threads under some circumstances but this is not guaranteed. For example, users can apply and remove the `INBOX` and `UNREAD` labels from messages and threads, but cannot apply or remove the `DRAFTS` or `SENT` labels from messages or threads.
One of: system, user

Referenced models: Creates a label For more information, see Manage labels (https: developers google com workspace gmail api guides labels) — response body — color

Creates a label For more information, see Manage labels (https: developers google com workspace gmail api guides labels) — response body — color
FieldTypePresenceDescription and constraints
$objectRoot
backgroundColorstringOptionalThe background color represented as hex string #RRGGBB (ex #000000). This field is required in order to set the color of a label. Only the following predefined set of color values are allowed: \#000000, #434343, #666666, #999999, #cccccc, #efefef, #f3f3f3, #ffffff, \#fb4c2f, #ffad47, #fad165, #16a766, #43d692, #4a86e8, #a479e2, #f691b3, \#f6c5be, #ffe6c7, #fef1d1, #b9e4d0, #c6f3de, #c9daf8, #e4d7f5, #fcdee8, \#efa093, #ffd6a2, #fce8b3, #89d3b2, #a0eac9, #a4c2f4, #d0bcf1, #fbc8d9, \#e66550, #ffbc6b, #fcda83, #44b984, #68dfa9, #6d9eeb, #b694e8, #f7a7c0, \#cc3a21, #eaa041, #f2c960, #149e60, #3dc789, #3c78d8, #8e63ce, #e07798, \#ac2b16, #cf8933, #d5ae49, #0b804b, #2a9c68, #285bac, #653e9b, #b65775, \#822111, #a46a21, #aa8831, #076239, #1a764d, #1c4587, #41236d, #83334c, \#464646, #e7e7e7, #0d3472, #b6cff5, #0d3b44, #98d7e4, #3d188e, #e3d7ff, \#711a36, #fbd3e0, #8a1c0a, #f2b2a8, #7a2e0b, #ffc8af, #7a4706, #ffdeb5, \#594c05, #fbe983, #684e07, #fdedc1, #0b4f30, #b3efd3, #04502e, #a2dcc1, \#c2c2c2, #4986e7, #2da2bb, #b99aff, #994a64, #f691b2, #ff7537, #ffad46, \#662e37, #ebdbde, #cca6ac, #094228, #42d692, #16a765, #757575, #1e53b8, \#007286, #7858c3, #c2185b, #d93025, #54240e, #633e04, #521d28, #202124, \#083018
textColorstringOptionalThe text color of the label, represented as hex string. This field is required in order to set the color of a label. Only the following predefined set of color values are allowed: \#000000, #434343, #666666, #999999, #cccccc, #efefef, #f3f3f3, #ffffff, \#fb4c2f, #ffad47, #fad165, #16a766, #43d692, #4a86e8, #a479e2, #f691b3, \#f6c5be, #ffe6c7, #fef1d1, #b9e4d0, #c6f3de, #c9daf8, #e4d7f5, #fcdee8, \#efa093, #ffd6a2, #fce8b3, #89d3b2, #a0eac9, #a4c2f4, #d0bcf1, #fbc8d9, \#e66550, #ffbc6b, #fcda83, #44b984, #68dfa9, #6d9eeb, #b694e8, #f7a7c0, \#cc3a21, #eaa041, #f2c960, #149e60, #3dc789, #3c78d8, #8e63ce, #e07798, \#ac2b16, #cf8933, #d5ae49, #0b804b, #2a9c68, #285bac, #653e9b, #b65775, \#822111, #a46a21, #aa8831, #076239, #1a764d, #1c4587, #41236d, #83334c, \#464646, #e7e7e7, #0d3472, #b6cff5, #0d3b44, #98d7e4, #3d188e, #e3d7ff, \#711a36, #fbd3e0, #8a1c0a, #f2b2a8, #7a2e0b, #ffc8af, #7a4706, #ffdeb5, \#594c05, #fbe983, #684e07, #fdedc1, #0b4f30, #b3efd3, #04502e, #a2dcc1, \#c2c2c2, #4986e7, #2da2bb, #b99aff, #994a64, #f691b2, #ff7537, #ffad46, \#662e37, #ebdbde, #cca6ac, #094228, #42d692, #16a765, #757575, #1e53b8, \#007286, #7858c3, #c2185b, #d93025, #54240e, #633e04, #521d28, #202124, \#083018

SDK function policy ID: google.gmail_users_labels_create. Catalog operation: gmail.users.labels.create. Rules can name either ID; function rules distinguish managed calls and conservatively cover raw calls sharing the route. Existing grant permissions and policy rules apply. wait() returns an immediate result or waits for a required approval; it never approves the request itself. Persist the approval ID to resume after a restart.

Provider errors retain their response; JSON decoding raises ProviderAPIError for provider failures. ManagedOperationError identifies contract/input/retention errors. See error handling and provider-specific behavior. Sensitive input may be refused before approval storage. A decoding error never resubmits a write.

Required provider scopes: ["https://mail.google.com/", "https://www.googleapis.com/auth/gmail.labels", "https://www.googleapis.com/auth/gmail.modify"]

Official provider source

Report an issue with this page

Necessary

Required for sign-in, security, authorization, and remembering your choices.

Always active

Analytics

Helps us understand which product and documentation features are useful.

Performance diagnostics

Uses performance tracing and privacy-masked session replay to diagnose problems.

You can change these choices at any time from Cookie settings.